﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace _91504
{
    class CustomObject:INotifyPropertyChanged
    {
        string fNameBrowsable;
        [Browsable(true)]
        public string FNameBrowsable
        {
            get { return fNameBrowsable; }
            set { fNameBrowsable = value;
            NotifyPropertyChanged("fNameBrowsable");
            }
        }

        string sNameBrowsable;
        [Browsable(true)]
        public string SNameBrowsable
        {
            get { return sNameBrowsable; }
            set { sNameBrowsable = value;
            NotifyPropertyChanged("sNameBrowsable");
            }
        }

        string fName;
        [Browsable(false)]
        public string FName
        {
            get { return fName; }
            set { fName = value;
            NotifyPropertyChanged("fName");
            }
        }

        string sName;
        [Browsable(false)]
        public string SName
        {
            get { return sName; }
            set { sName = value;
            NotifyPropertyChanged("sName");
            }
        }

        [Browsable(true)]
        public string NameConcatenateBrowsable
        {
            get { return string.Format("{0} {1}", fNameBrowsable, sNameBrowsable); }

            set
            {
                NotifyPropertyChanged("NameConcatenateBrowsable");
                if (string.IsNullOrEmpty(value))
                {
                    FNameBrowsable = value;
                    SNameBrowsable = value;
                }
                else
                {
                    string[] names = value.Split(new char[] { ' ' });
                    FNameBrowsable = names[0];
                    SNameBrowsable = value.Substring(value.IndexOf(fNameBrowsable) + fNameBrowsable.Length);
                }
            }
        }

        [Browsable(true)]
        public string NameConcatenate
        {
            get { return string.Format("{0} {1}", fName, sName); }

            set
            {
                NotifyPropertyChanged("NameConcatenate");
                if (string.IsNullOrEmpty(value))
                {
                    FName = value;
                    SName = value;
                }
                else
                {
                    string[] names = value.Split(new char[] { ' ' });
                    FName = names[0];
                    SName = value.Substring(value.IndexOf(fName) + fName.Length);
                }
            }
        }

        public static BindingList<CustomObject> GetListCustomObject(int count)
        {
            BindingList<CustomObject> ret = new BindingList<CustomObject>();

            for (int i = 0; i < count; i++)
            {
                CustomObject co = new CustomObject()
                {
                    FName = string.Format("Name{0}", i),
                    SName = string.Format("SName{0}", i),
                    FNameBrowsable = string.Format("BrowsableName{0}", i),
                    SNameBrowsable = string.Format("BrowsableName{0}", i)
                };

                ret.Add(co);
            }
            return ret;
        }


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        #endregion
    }
}
